package djmil.cordacheckers;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.security.core.annotation.AuthenticationPrincipal;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import djmil.cordacheckers.cordaclient.CordaClient;
import djmil.cordacheckers.cordaclient.dao.VirtualNode;

@RestController
public class ApiController {

    @Autowired
    CordaClient cordaClient;

    @GetMapping("/api/badjokes")
    public ResponseEntity<Joke> badJokes() {

        List<VirtualNode> vNodeList = cordaClient.getVirtualNodeList();

        Joke joke = new Joke("What do you call a fly without wings? A walk! " + vNodeList.get(1).holdingIdentity().x500Name());

        return ResponseEntity.ok(joke);
    }

    /**
     * 
     * @return a Json list of active games
     */
    @GetMapping("/api/gameproposals")
    public ResponseEntity<String> dashboard(@AuthenticationPrincipal ApiUserDetails user) {
        System.out.println("List of active games for "
            + "user: " + user.getUsername()
            + " with HoldingIdentity ShortHash: " + user.getHoldingIdentity().shortHash());

        return ResponseEntity.ok("{ \"UnconsumedGameProposals\" : [\"id_game1\", \"id_game2\"] }" );
    }

}