package djmil.cordacheckers.cordaclient;

import org.junit.jupiter.api.Test;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import com.fasterxml.jackson.core.JsonProcessingException;

import djmil.cordacheckers.cordaclient.dao.VirtualNode;

import static org.assertj.core.api.Assertions.assertThat;

import java.util.List;

import javax.naming.InvalidNameException;

@SpringBootTest
public class CordaClientTest {
    @Autowired
    CordaClient cordaClient;

    @Autowired
    HoldingIdentityResolver holdingIdentityResolver;

    @Test
    void testGetVirtualNodeList() throws InvalidNameException {
        List<VirtualNode> vNodes = cordaClient.getVirtualNodeList();

		assertThat(vNodes.size()).isEqualTo(5); // default vNode config for CSDE
    }

    @Test
    void testListGameProposals() throws JsonProcessingException {
        String resp = cordaClient.listGameProposals(
            holdingIdentityResolver.getByCommonName("alice"));

        System.out.println("testListGameProposals "+ resp);
    }

}
