package djmil.cordacheckers.gameproposal;

import java.util.stream.Collectors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import djmil.cordacheckers.states.GameProposalState;
import net.corda.v5.application.flows.ClientRequestBody;
import net.corda.v5.application.flows.ClientStartableFlow;
import net.corda.v5.application.flows.CordaInject;
import net.corda.v5.application.marshalling.JsonMarshallingService;
import net.corda.v5.ledger.utxo.StateAndRef;
import net.corda.v5.ledger.utxo.UtxoLedgerService;

public class ListFlow implements ClientStartableFlow {

    private final static Logger log = LoggerFactory.getLogger(ListFlow.class);

    @CordaInject
    public UtxoLedgerService utxoLedgerService;

    @CordaInject
    public JsonMarshallingService jsonMarshallingService;

    @Override
    public String call(ClientRequestBody requestBody) {
        log.info("ListChatsFlow.call() called");

        // Queries the VNode's vault for unconsumed states and converts the result to a serializable DTO.
        java.util.List<StateAndRef<GameProposalState>> states = utxoLedgerService.findUnconsumedStatesByType(GameProposalState.class);

        java.util.List<ListItem> results = states.stream().map( stateAndRef -> 
            new ListItem(stateAndRef.getState().getContractState())
        ).collect(Collectors.toList());

        // Uses the JsonMarshallingService's format() function to serialize the DTO to Json.
        return jsonMarshallingService.format(results);
    }
    
}
