package djmil.cordacheckers.gameproposal;

import java.util.UUID;

import djmil.cordacheckers.states.GameProposalState;

// Class to hold results of the List flow.
// The GameProposal(s) cannot be returned directly as the JsonMarshallingService can only serialize simple classes
// that the underlying Jackson serializer recognises, hence creating a DTO style object which consists only of Strings
// and a UUID. It is possible to create custom serializers for the JsonMarshallingService in the future.

public class ListItem {
    public final String sender;
    public final String recipient;
    public final String youPlayAs;
    public final String additionalMessage;
    public final UUID id;

    // Serialisation service requires a default constructor
    public ListItem() { 
        this.sender = null;
        this.recipient = null;
        this.youPlayAs = null;
        this.additionalMessage = null;
        this.id = null;
    }

    public ListItem(GameProposalState state) {
        this.sender    = state.getSenderCommonName();
        this.recipient = state.getRecipientCommonName();
        this.youPlayAs = state.getYouPlayAs().name();
        this.additionalMessage = state.getAdditionalMessage();
        this.id        = state.getId();
    }
}
